# Report estimates of average search decisions and arrival rates.

# Before running this program, first run the code for sections 2 and 3
# from the function like.sml (in likeli_SML.R), in the global environment.
# This produces the objects ED.xxx and Elam.xxx needed below.



### SEARCH DECISION

# A) Boys

# Search probabilities conditional on type:

  rbind(
colMeans( rbind(
  ED.F94[virgins.b9[vov.b9.F94],], ED.F95[virgins.b8[vov.b8.F95],],
  ED.W95[virgins.b9[vov.b9.W95],], ED.W96[virgins.b8[vov.b8.W96],],
  ED.S95[virgins.b9[vov.b9.S95],], ED.S96[virgins.b8[vov.b8.S96],],
  ED.U95[virgins.b9[vov.b9.U95],]
  ) ),
colMeans( rbind(
  ED.F94[virgins.b10[vov.b10.F94],], ED.F95[virgins.b9[vov.b9.F95],],
  ED.W95[virgins.b10[vov.b10.W95],], ED.W96[virgins.b9[vov.b9.W96],],
  ED.S95[virgins.b10[vov.b10.S95],], ED.S96[virgins.b9[vov.b9.S96],],
  ED.U95[virgins.b10[vov.b10.U95],]
  ) ),
colMeans( rbind(
  ED.F94[virgins.b11[vov.b11.F94],], ED.F95[virgins.b10[vov.b10.F95],],
  ED.W95[virgins.b11[vov.b11.W95],], ED.W96[virgins.b10[vov.b10.W96],],
  ED.S95[virgins.b11[vov.b11.S95],], ED.S96[virgins.b10[vov.b10.S96],],
  ED.U95[virgins.b11[vov.b11.U95],]
  ) ),
colMeans( rbind(
  ED.F94[virgins.b12[vov.b12.F94],], ED.F95[virgins.b11[vov.b11.F95],],
  ED.W95[virgins.b12[vov.b12.W95],], ED.W96[virgins.b11[vov.b11.W96],],
  ED.S95[virgins.b12[vov.b12.S95],], ED.S96[virgins.b11[vov.b11.S96],]
  ) ) )

# Weighted average search probabilities:

  rbind(
mean( rowSums( rbind(
  ED.F94[virgins.b9[vov.b9.F94],], ED.F95[virgins.b8[vov.b8.F95],],
  ED.W95[virgins.b9[vov.b9.W95],], ED.W96[virgins.b8[vov.b8.W96],],
  ED.S95[virgins.b9[vov.b9.S95],], ED.S96[virgins.b8[vov.b8.S96],],
  ED.U95[virgins.b9[vov.b9.U95],] ) * rbind(
  PI[virgins.b9[vov.b9.F94],], PI[virgins.b8[vov.b8.F95],],
  PI[virgins.b9[vov.b9.W95],], PI[virgins.b8[vov.b8.W96],],
  PI[virgins.b9[vov.b9.S95],], PI[virgins.b8[vov.b8.S96],],
  PI[virgins.b9[vov.b9.U95],] ) 
  ) ),
mean( rowSums( rbind(
  ED.F94[virgins.b10[vov.b10.F94],], ED.F95[virgins.b9[vov.b9.F95],],
  ED.W95[virgins.b10[vov.b10.W95],], ED.W96[virgins.b9[vov.b9.W96],],
  ED.S95[virgins.b10[vov.b10.S95],], ED.S96[virgins.b9[vov.b9.S96],],
  ED.U95[virgins.b10[vov.b10.U95],] ) * rbind(
  PI[virgins.b10[vov.b10.F94],], PI[virgins.b9[vov.b9.F95],],
  PI[virgins.b10[vov.b10.W95],], PI[virgins.b9[vov.b9.W96],],
  PI[virgins.b10[vov.b10.S95],], PI[virgins.b9[vov.b9.S96],],
  PI[virgins.b10[vov.b10.U95],] )
  ) ),
mean( rowSums( rbind(
  ED.F94[virgins.b11[vov.b11.F94],], ED.F95[virgins.b10[vov.b10.F95],],
  ED.W95[virgins.b11[vov.b11.W95],], ED.W96[virgins.b10[vov.b10.W96],],
  ED.S95[virgins.b11[vov.b11.S95],], ED.S96[virgins.b10[vov.b10.S96],],
  ED.U95[virgins.b11[vov.b11.U95],] ) * rbind(
  PI[virgins.b11[vov.b11.F94],], PI[virgins.b10[vov.b10.F95],],
  PI[virgins.b11[vov.b11.W95],], PI[virgins.b10[vov.b10.W96],],
  PI[virgins.b11[vov.b11.S95],], PI[virgins.b10[vov.b10.S96],],
  PI[virgins.b11[vov.b11.U95],] ) 
  ) ),
mean( rowSums( rbind(
  ED.F94[virgins.b12[vov.b12.F94],], ED.F95[virgins.b11[vov.b11.F95],],
  ED.W95[virgins.b12[vov.b12.W95],], ED.W96[virgins.b11[vov.b11.W96],],
  ED.S95[virgins.b12[vov.b12.S95],], ED.S96[virgins.b11[vov.b11.S96],] ) * rbind(
  PI[virgins.b12[vov.b12.F94],], PI[virgins.b11[vov.b11.F95],],
  PI[virgins.b12[vov.b12.W95],], PI[virgins.b11[vov.b11.W96],],
  PI[virgins.b12[vov.b12.S95],], PI[virgins.b11[vov.b11.S96],] ) 
  ) ) 
  )

# B) Girls

# Search probabilities conditional on type:

  rbind(
colMeans( rbind(
  ED.F94[virgins.g9[vov.g9.F94],], ED.F95[virgins.g8[vov.g8.F95],],
  ED.W95[virgins.g9[vov.g9.W95],], ED.W96[virgins.g8[vov.g8.W96],],
  ED.S95[virgins.g9[vov.g9.S95],], ED.S96[virgins.g8[vov.g8.S96],],
  ED.U95[virgins.g9[vov.g9.U95],]
  ) ),
colMeans( rbind(
  ED.F94[virgins.g10[vov.g10.F94],], ED.F95[virgins.g9[vov.g9.F95],],
  ED.W95[virgins.g10[vov.g10.W95],], ED.W96[virgins.g9[vov.g9.W96],],
  ED.S95[virgins.g10[vov.g10.S95],], ED.S96[virgins.g9[vov.g9.S96],],
  ED.U95[virgins.g10[vov.g10.U95],]
  ) ),
colMeans( rbind(
  ED.F94[virgins.g11[vov.g11.F94],], ED.F95[virgins.g10[vov.g10.F95],],
  ED.W95[virgins.g11[vov.g11.W95],], ED.W96[virgins.g10[vov.g10.W96],],
  ED.S95[virgins.g11[vov.g11.S95],], ED.S96[virgins.g10[vov.g10.S96],],
  ED.U95[virgins.g11[vov.g11.U95],]
  ) ),
colMeans( rbind(
  ED.F94[virgins.g12[vov.g12.F94],], ED.F95[virgins.g11[vov.g11.F95],],
  ED.W95[virgins.g12[vov.g12.W95],], ED.W96[virgins.g11[vov.g11.W96],],
  ED.S95[virgins.g12[vov.g12.S95],], ED.S96[virgins.g11[vov.g11.S96],]
  ) ) ) 

# Weighted average search probabilities:

  rbind(
mean( rowSums( rbind(
  ED.F94[virgins.g9[vov.g9.F94],], ED.F95[virgins.g8[vov.g8.F95],],
  ED.W95[virgins.g9[vov.g9.W95],], ED.W96[virgins.g8[vov.g8.W96],],
  ED.S95[virgins.g9[vov.g9.S95],], ED.S96[virgins.g8[vov.g8.S96],],
  ED.U95[virgins.g9[vov.g9.U95],] ) * rbind(
  PI[virgins.g9[vov.g9.F94],], PI[virgins.g8[vov.g8.F95],],
  PI[virgins.g9[vov.g9.W95],], PI[virgins.g8[vov.g8.W96],],
  PI[virgins.g9[vov.g9.S95],], PI[virgins.g8[vov.g8.S96],],
  PI[virgins.g9[vov.g9.U95],] ) 
  ) ),
mean( rowSums( rbind(
  ED.F94[virgins.g10[vov.g10.F94],], ED.F95[virgins.g9[vov.g9.F95],],
  ED.W95[virgins.g10[vov.g10.W95],], ED.W96[virgins.g9[vov.g9.W96],],
  ED.S95[virgins.g10[vov.g10.S95],], ED.S96[virgins.g9[vov.g9.S96],],
  ED.U95[virgins.g10[vov.g10.U95],] ) * rbind(
  PI[virgins.g10[vov.g10.F94],], PI[virgins.g9[vov.g9.F95],],
  PI[virgins.g10[vov.g10.W95],], PI[virgins.g9[vov.g9.W96],],
  PI[virgins.g10[vov.g10.S95],], PI[virgins.g9[vov.g9.S96],],
  PI[virgins.g10[vov.g10.U95],] )
  ) ),
mean( rowSums( rbind(
  ED.F94[virgins.g11[vov.g11.F94],], ED.F95[virgins.g10[vov.g10.F95],],
  ED.W95[virgins.g11[vov.g11.W95],], ED.W96[virgins.g10[vov.g10.W96],],
  ED.S95[virgins.g11[vov.g11.S95],], ED.S96[virgins.g10[vov.g10.S96],],
  ED.U95[virgins.g11[vov.g11.U95],] ) * rbind(
  PI[virgins.g11[vov.g11.F94],], PI[virgins.g10[vov.g10.F95],],
  PI[virgins.g11[vov.g11.W95],], PI[virgins.g10[vov.g10.W96],],
  PI[virgins.g11[vov.g11.S95],], PI[virgins.g10[vov.g10.S96],],
  PI[virgins.g11[vov.g11.U95],] ) 
  ) ),
mean( rowSums( rbind(
  ED.F94[virgins.g12[vov.g12.F94],], ED.F95[virgins.g11[vov.g11.F95],],
  ED.W95[virgins.g12[vov.g12.W95],], ED.W96[virgins.g11[vov.g11.W96],],
  ED.S95[virgins.g12[vov.g12.S95],], ED.S96[virgins.g11[vov.g11.S96],] ) * rbind(
  PI[virgins.g12[vov.g12.F94],], PI[virgins.g11[vov.g11.F95],],
  PI[virgins.g12[vov.g12.W95],], PI[virgins.g11[vov.g11.W96],],
  PI[virgins.g12[vov.g12.S95],], PI[virgins.g11[vov.g11.S96],] ) 
  ) ) 
  )



### ARRIVAL RATE

# Run internal code for like.sml to get Elam for initial virgins.

cbind(
# Boys:
  rbind(
mean( c(
  Elam.F94[virgins.b9[vov.b9.F94]], Elam.F95[virgins.b8[vov.b8.F95]],
  Elam.W95[virgins.b9[vov.b9.W95]], Elam.W96[virgins.b8[vov.b8.W96]],
  Elam.S95[virgins.b9[vov.b9.S95]], Elam.S96[virgins.b8[vov.b8.S96]],
  Elam.U95[virgins.b9[vov.b9.U95]]
  ) ),
mean( c(
  Elam.F94[virgins.b10[vov.b10.F94]], Elam.F95[virgins.b9[vov.b9.F95]],
  Elam.W95[virgins.b10[vov.b10.W95]], Elam.W96[virgins.b9[vov.b9.W96]],
  Elam.S95[virgins.b10[vov.b10.S95]], Elam.S96[virgins.b9[vov.b9.S96]],
  Elam.U95[virgins.b10[vov.b10.U95]]
  ) ),
mean( c(
  Elam.F94[virgins.b11[vov.b11.F94]], Elam.F95[virgins.b10[vov.b10.F95]],
  Elam.W95[virgins.b11[vov.b11.W95]], Elam.W96[virgins.b10[vov.b10.W96]],
  Elam.S95[virgins.b11[vov.b11.S95]], Elam.S96[virgins.b10[vov.b10.S96]],
  Elam.U95[virgins.b11[vov.b11.U95]]
  ) ),
mean( c(
  Elam.F94[virgins.b12[vov.b12.F94]], Elam.F95[virgins.b11[vov.b11.F95]],
  Elam.W95[virgins.b12[vov.b12.W95]], Elam.W96[virgins.b11[vov.b11.W96]],
  Elam.S95[virgins.b12[vov.b12.S95]], Elam.S96[virgins.b11[vov.b11.S96]]
  ) ) ),
# Girls:
  rbind(
mean( c(
  Elam.F94[virgins.g9[vov.g9.F94]], Elam.F95[virgins.g8[vov.g8.F95]],
  Elam.W95[virgins.g9[vov.g9.W95]], Elam.W96[virgins.g8[vov.g8.W96]],
  Elam.S95[virgins.g9[vov.g9.S95]], Elam.S96[virgins.g8[vov.g8.S96]],
  Elam.U95[virgins.g9[vov.g9.U95]]
  ) ),
mean( c(
  Elam.F94[virgins.g10[vov.g10.F94]], Elam.F95[virgins.g9[vov.g9.F95]],
  Elam.W95[virgins.g10[vov.g10.W95]], Elam.W96[virgins.g9[vov.g9.W96]],
  Elam.S95[virgins.g10[vov.g10.S95]], Elam.S96[virgins.g9[vov.g9.S96]],
  Elam.U95[virgins.g10[vov.g10.U95]]
  ) ),
mean( c(
  Elam.F94[virgins.g11[vov.g11.F94]], Elam.F95[virgins.g10[vov.g10.F95]],
  Elam.W95[virgins.g11[vov.g11.W95]], Elam.W96[virgins.g10[vov.g10.W96]],
  Elam.S95[virgins.g11[vov.g11.S95]], Elam.S96[virgins.g10[vov.g10.S96]],
  Elam.U95[virgins.g11[vov.g11.U95]]
  ) ),
mean( c(
  Elam.F94[virgins.g12[vov.g12.F94]], Elam.F95[virgins.g11[vov.g11.F95]],
  Elam.W95[virgins.g12[vov.g12.W95]], Elam.W96[virgins.g11[vov.g11.W96]],
  Elam.S95[virgins.g12[vov.g12.S95]], Elam.S96[virgins.g11[vov.g11.S96]]
  ) ) ) 
  )



### TYPE DISTRIBUTION

temp.avg <- matrix(nrow=4,ncol=2)

mean(PI[c(virgins.b8,virgins.b9),3]) -> temp.avg[1,1]
mean(PI[c(virgins.g8,virgins.g9),3]) -> temp.avg[1,2]
mean(PI[virgins.b10,3]) -> temp.avg[2,1]
mean(PI[virgins.g10,3]) -> temp.avg[2,2]
mean(PI[virgins.b11,3]) -> temp.avg[3,1]
mean(PI[virgins.g11,3]) -> temp.avg[3,2]
mean(PI[virgins.b12,3]) -> temp.avg[4,1]
mean(PI[virgins.g12,3]) -> temp.avg[4,2]

temp.avg


