### LOAD FUNCTIONS

setwd("~/data/replication/code/estimation")

# Main likelihood:

source("likeli_SML.R")

# Function for individual contributions:
# (for variance estimation)

source("like_contrib.R")

# Helper functions:

source("helperfns/expsupply.R")
source("helperfns/searchapprox.R")
source("helperfns/valuediff_fns.R")



### STARTING VALUES

# Transition probabilities:
# (for updating types distribution)

Laux.b.F9 <- Laux.b.F10 <- Laux.b.F11 <- 
Laux.b.W9 <- Laux.b.W10 <- Laux.b.W11 <- 
Laux.b.S9 <- Laux.b.S10 <- Laux.b.S11 <- 
Laux.b.U9 <- Laux.b.U10 <- Laux.b.U11 <- 
  cbind(rep(0.1, 1+8+4),rep(0.1, 1+8+4),rep(0.1, 1+8+4) )

Laux.g.F9 <- Laux.g.F10 <- Laux.g.F11 <-
Laux.g.W9 <- Laux.g.W10 <- Laux.g.W11 <-
Laux.g.S9 <- Laux.g.S10 <- Laux.g.S11 <-
Laux.g.U9 <- Laux.g.U10 <- Laux.g.U11 <-
  cbind(rep(0.1, 1+8+4),rep(0.1, 1+8+4),rep(0.1, 1+8+4) )



### SAVE

setwd("~/data/replication/created")

save.image("workingfile.RData")
