### EVALUATION FUNCTION

Sum9 <- function() {

### 1) INDIVIDUAL DECISION

# Predicted h (agg. state):

                Eh0.b <- Eh.b <- psi.chg(h.b)
Eh0.b[,p.b10] <- h.b[,p.b9]/pop.Pb + Eh.b[,p.b10]*(pop.Pb-1)/pop.Pb
Eh.b[,p.b10] <- Eh0.b[,p.b10] + 1/pop.Pb;           E2h.b <- psi.qtr(Eh.b);   E3h.b <- psi.qtr(E2h.b)
E4h.b <- psi.ann(h.b); E4h.b[,p.b10] <- (h.b[,p.b9]+1)/pop.Pb + E4h.b[,p.b9]*(pop.Pb-1)/pop.Pb
                         E5h.b <- psi.chg(E4h.b); E6h.b <- psi.qtr(E5h.b);  E7h.b <- psi.qtr(E6h.b)
E8h.b <- psi.ann(E4h.b); E9h.b <- psi.chg(E8h.b); E10h.b <- psi.qtr(E9h.b); E11h.b <- psi.qtr(E10h.b)

                Eh0.g <- Eh.g <- psi.chg(h.g)
Eh0.g[,p.g10] <- h.g[,p.g9]/pop.Pg + Eh.g[,p.g10]*(pop.Pg-1)/pop.Pg
Eh.g[,p.g10] <- Eh0.g[,p.g10] + 1/pop.Pg;           E2h.g <- psi.qtr(Eh.g);   E3h.g <- psi.qtr(E2h.g)
E4h.g <- psi.ann(h.g); E4h.g[,p.g10] <- (h.g[,p.g9]+1)/pop.Pg + E4h.g[,p.g10]*(pop.Pg-1)/pop.Pg
                         E5h.g <- psi.chg(E4h.g); E6h.g <- psi.qtr(E5h.g);  E7h.g <- psi.qtr(E6h.g)
E8h.g <- psi.ann(E4h.g); E9h.g <- psi.chg(E8h.g); E10h.g <- psi.qtr(E9h.g); E11h.g <- psi.qtr(E10h.g)

# Threshold:

valuediff.b <- W.b[k.b]/(1-B) + 
  a.b9 + sum(B^(1:4))*a.b10 + sum(B^(5:8))*a.b11 + sum(B^(9:11))*a.b12 + 
  a1.b*(sum(B^(0:11)*(4:15)) + B^12*16/(1-B))/10 +
  g.b * ( h.b[,p.b9] 
         + B*Eh.b[,p.b10] + B^2*E2h.b[,p.b10] + B^3*E3h.b[,p.b10] + B^4*E4h.b[,p.b10] 
         + B^5*E5h.b[,p.b11] + B^6*E6h.b[,p.b11] + B^7*E7h.b[,p.b11] + B^8*E8h.b[,p.b11] 
         + B^9*E9h.b[,p.b12] + B^10*E10h.b[,p.b12] + B^11*E11h.b[,p.b12]/(1-B*d) ) -
 B*EV0hat.b.F10(W.b[k.b], Eh0.b, Xbar.Mb, pop.Pb, nosupply.b) 

valuediff.g <- W.g[k.g]/(1-B) + 
  a.g9 + sum(B^(1:4))*a.g10 + sum(B^(5:8))*a.g11 + sum(B^(9:11))*a.g12 + 
  a1.g*(sum(B^(0:11)*(4:15)) + B^12*16/(1-B))/10 +
  g.g * ( h.g[,p.g9] 
         + B*Eh.g[,p.g10] + B^2*E2h.g[,p.g10] + B^3*E3h.g[,p.g10] + B^4*E4h.g[,p.g10] 
         + B^5*E5h.g[,p.g11] + B^6*E6h.g[,p.g11] + B^7*E7h.g[,p.g11] + B^8*E8h.g[,p.g11] 
         + B^9*E9h.g[,p.g12] + B^10*E10h.g[,p.g12] + B^11*E11h.g[,p.g12]/(1-B*d) ) -
  B*EV0hat.g.F10(W.g[k.g], Eh0.g, Xbar.Mg, pop.Pg, nosupply.g) 

### 2) SUPPLY

Elam.b <- numeric(Pts) + as.vector( Match(lambda.b9)(cbind(0,0) ) )
Elam.g <- numeric(Pts) + as.vector( Match(lambda.g9)(cbind(0,0,0) ) )

# Boys:

for (i in 1:Pts)  {
  pop.m1 <- pop.Mb[i,1]; pop.m2 <- pop.Mb[i,2]; pop.m3 <- pop.Mb[i,3]; pop.p <- pop.Pb[i]
  pop.c1 <- pop.Cb[i,1]; pop.c2 <- pop.Cb[i,2]; pop.c3 <- pop.Cb[i,3]
  #
  # M1) Same grade:
if (pop.m1 > 0)  {
  # Probabilities:
Dpred.m1 <- Dpred.g.U9[1] + Dp2.g.U9*h.b[i,m.b9[1]]
  # Simulations:
D.m1 <- ( as.vector(Dpred.m1) > unif.Mb[[i]][[1]] )
  # Supplies:
N.m1 <- colSums(D.m1, na.rm=TRUE)
    }
  # C1) Same grade:
if (pop.c1 > 0)  {
  # Probabilities:
Dpred.c1 <- Dpred.b.U9[1] + Dp2.b.U9*h.b[i,c.b9[1]]
  # Simulations:
D.c1 <- ( as.vector(Dpred.c1) > unif.Cb[[i]][[1]] )
  # Supplies:
N.c1 <- colSums(D.c1, na.rm=TRUE)
N.m1 <- N.m1/N.c1  #  (otherwise use N.m1/1)
    }
  # M3) Grade above:
if (pop.m3 > 0)  {
  # Probabilities:
Dpred.m3 <- Dpred.g.U10[1] + Dp2.g.U10*h.b[i,m.b9[3]]
  # Simulations:
D.m3 <- ( as.vector(Dpred.m3) > unif.Mb[[i]][[3]] )
  # Supplies:
N.m3 <- colSums(D.m3, na.rm=TRUE)
    }
  # C3) Grade above:
if (pop.c3 > 0)  {
  # Probabilities:
Dpred.c3 <- Dpred.b.U10[1] + Dp2.b.U10*h.b[i,c.b9[3]]
  # Simulations:
D.c3 <- ( as.vector(Dpred.c3) > unif.Cb[[i]][[3]] )
  # Supplies:
N.c3 <- colSums(D.c3, na.rm=TRUE)
N.m3 <- N.m3/N.c3  #  (otherwise use N.m3/1)
    }
  # Match function:
Elam.b[i] <- mean( Match(lambda.b9)(cbind(N.m1,N.m3) ) ) 
  }

# Girls:

for (i in 1:Pts)  {
  pop.m1 <- pop.Mg[i,1]; pop.m2 <- pop.Mg[i,2]; pop.m3 <- pop.Mg[i,3]; pop.p <- pop.Pg[i]
  pop.c1 <- pop.Cg[i,1]; pop.c2 <- pop.Cg[i,2]; pop.c3 <- pop.Cg[i,3]
  #
  # M1) Same grade:
if (pop.m1 > 0)  {
  # Probabilities:
Dpred.m1 <- Dpred.b.U9[1] + Dp2.b.U9*h.g[i,m.g9[1]]
  # Simulations:
D.m1 <- ( as.vector(Dpred.m1) > unif.Mg[[i]][[1]] )
  # Supplies:
N.m1 <- colSums(D.m1, na.rm=TRUE)
    }
  # C1) Same grade:
if (pop.c1 > 0)  {
  # Probabilities:
Dpred.c1 <- Dpred.g.U9[1] + Dp2.g.U9*h.g[i,c.g9[1]]
  # Simulations:
D.c1 <- ( as.vector(Dpred.c1) > unif.Cg[[i]][[1]] )
  # Supplies:
N.c1 <- colSums(D.c1, na.rm=TRUE)
N.m1 <- N.m1/N.c1  #  (otherwise use N.m1/1)
    }
  # M2) Grade above:
if (pop.m2 > 0)  {
  # Probabilities:
Dpred.m2 <- Dpred.b.U10[1] + Dp2.b.U10*h.g[i,m.g9[2]]
  # Simulations:
D.m2 <- ( as.vector(Dpred.m2) > unif.Mg[[i]][[2]] )
  # Supplies:
N.m2 <- colSums(D.m2, na.rm=TRUE)
    }
  # C2) Grade above:
if (pop.c2 > 0)  {
  # Probabilities:
Dpred.c2 <- Dpred.g.U10[1] + Dp2.g.U10*h.g[i,c.g9[2]]
  # Simulations:
D.c2 <- ( as.vector(Dpred.c2) > unif.Cg[[i]][[2]] )
  # Supplies:
N.c2 <- colSums(D.c2, na.rm=TRUE)
N.m2 <- N.m2/N.c2  #  (otherwise use N.m2/1)
    }
  # M3) Two above:
if (pop.m3 > 0)  {
  # Probabilities:
Dpred.m3 <- Dpred.b.U11[1] + Dp2.b.U11*h.g[i,m.g9[3]]
  # Simulations:
D.m3 <- ( as.vector(Dpred.m3) > unif.Mg[[i]][[3]] )
  # Supplies:
N.m3 <- colSums(D.m3, na.rm=TRUE)
    }
  # C3) Two above:
if (pop.c3 > 0)  {
  # Probabilities:
Dpred.c3 <- Dpred.g.U11[1] + Dp2.g.U11*h.g[i,c.g9[3]]
  # Simulations:
D.c3 <- ( as.vector(Dpred.c3) > unif.Cg[[i]][[3]] )
  # Supplies:
N.c3 <- colSums(D.c3, na.rm=TRUE)
N.m3 <- N.m3/N.c3  #  (otherwise use N.m3/1)
    }
  # Match function:
Elam.g[i] <- mean( Match(lambda.g9)(cbind(N.m1,N.m2,N.m3) ) )
  }

### 3) EXPECTED VALUE

# Just surplus, excluding BEV^{t+1}(0,h):

EVgain.b <- pnorm(valuediff.b) * Elam.b * ( valuediff.b + Eeps(valuediff.b) )
EVgain.g <- pnorm(valuediff.g) * Elam.g * ( valuediff.g + Eeps(valuediff.g) )

### 4) INTERPOLATION

# Transformations:

valuediff.b <- as.vector( valuediff.b )
valuediff.g <- as.vector( valuediff.g )

surplus.b <- valuediff.b + Eeps(valuediff.b)
surplus.g <- valuediff.g + Eeps(valuediff.g)

# Approximation:

ipar.b.U9 <<- lm(EVgain.b ~ valuediff.b + I(valuediff.b^2) + I(valuediff.b^3) + h.b[,m.b9]
  + I(surplus.b*nosupply.b[,2]) + I(surplus.b*h.b[,m.b9]) + I(surplus.b*Xbar.Mb) )$coef
ipar.g.U9 <<- lm(EVgain.g ~ valuediff.g + I(valuediff.g^2) + I(valuediff.g^3) + h.g[,m.g9]
  + I(surplus.g*nosupply.g) + I(surplus.g*h.g[,m.g9]) + I(surplus.g*Xbar.Mg) )$coef

}                                                                # END




### INTERPOLATING FUNCTION

EV0hat.b.U9 <- function (w, h.b, Xbar.m, pop.Pb, nosupl)  {
                Eh0.b <- Eh.b <- psi.chg(h.b)
Eh0.b[,p.b10] <- h.b[,p.b9]/pop.Pb + Eh.b[,p.b10]*(pop.Pb-1)/pop.Pb
Eh.b[,p.b10] <- Eh0.b[,p.b10] + 1/pop.Pb;           E2h.b <- psi.qtr(Eh.b);   E3h.b <- psi.qtr(E2h.b)
E4h.b <- psi.ann(h.b); E4h.b[,p.b10] <- (h.b[,p.b9]+1)/pop.Pb + E4h.b[,p.b9]*(pop.Pb-1)/pop.Pb
                         E5h.b <- psi.chg(E4h.b); E6h.b <- psi.qtr(E5h.b);  E7h.b <- psi.qtr(E6h.b)
E8h.b <- psi.ann(E4h.b); E9h.b <- psi.chg(E8h.b); E10h.b <- psi.qtr(E9h.b); E11h.b <- psi.qtr(E10h.b)
  BEV0 <- B*EV0hat.b.F10(w, Eh0.b, Xbar.m, pop.Pb, nosupl)
  valuediff <- as.vector(
    w/(1-B) + 
  a.b9 + sum(B^(1:4))*a.b10 + sum(B^(5:8))*a.b11 + sum(B^(9:11))*a.b12 + 
  a1.b*(sum(B^(0:11)*(4:15)) + B^12*16/(1-B))/10 +
  g.b * ( h.b[,p.b9] 
         + B*Eh.b[,p.b10] + B^2*E2h.b[,p.b10] + B^3*E3h.b[,p.b10] + B^4*E4h.b[,p.b10] 
         + B^5*E5h.b[,p.b11] + B^6*E6h.b[,p.b11] + B^7*E7h.b[,p.b11] + B^8*E8h.b[,p.b11] 
         + B^9*E9h.b[,p.b12] + B^10*E10h.b[,p.b12] + B^11*E11h.b[,p.b12]/(1-B*d) ) - BEV0 ) 
  surplus <- as.vector( valuediff + Eeps(valuediff) )
  cbind(1, valuediff, valuediff^2, valuediff^3, h.b[,m.b9],
    surplus*nosupl[,2], surplus*h.b[,m.b9], surplus*Xbar.m)  %*% ipar.b.U9 + BEV0
  }

EV0hat.g.U9 <- function (w, h.g, Xbar.m, pop.Pg, nosupl)  {
                Eh0.g <- Eh.g <- psi.chg(h.g)
Eh0.g[,p.g10] <- h.g[,p.g9]/pop.Pg + Eh.g[,p.g10]*(pop.Pg-1)/pop.Pg
Eh.g[,p.g10] <- Eh0.g[,p.g10] + 1/pop.Pg;           E2h.g <- psi.qtr(Eh.g);   E3h.g <- psi.qtr(E2h.g)
E4h.g <- psi.ann(h.g); E4h.g[,p.g10] <- (h.g[,p.g9]+1)/pop.Pg + E4h.g[,p.g10]*(pop.Pg-1)/pop.Pg
                         E5h.g <- psi.chg(E4h.g); E6h.g <- psi.qtr(E5h.g);  E7h.g <- psi.qtr(E6h.g)
E8h.g <- psi.ann(E4h.g); E9h.g <- psi.chg(E8h.g); E10h.g <- psi.qtr(E9h.g); E11h.g <- psi.qtr(E10h.g)
  BEV0 <- B*EV0hat.g.F10(w, Eh0.g, Xbar.m, pop.Pg, nosupl)
  valuediff <- as.vector(
    w/(1-B) +
  a.g9 + sum(B^(1:4))*a.g10 + sum(B^(5:8))*a.g11 + sum(B^(9:11))*a.g12 + 
  a1.g*(sum(B^(0:11)*(4:15)) + B^12*16/(1-B))/10 +
  g.g * ( h.g[,p.g9] 
         + B*Eh.g[,p.g10] + B^2*E2h.g[,p.g10] + B^3*E3h.g[,p.g10] + B^4*E4h.g[,p.g10] 
         + B^5*E5h.g[,p.g11] + B^6*E6h.g[,p.g11] + B^7*E7h.g[,p.g11] + B^8*E8h.g[,p.g11] 
         + B^9*E9h.g[,p.g12] + B^10*E10h.g[,p.g12] + B^11*E11h.g[,p.g12]/(1-B*d) ) - BEV0 ) 
  surplus <- as.vector( valuediff + Eeps(valuediff) )
  cbind(1, valuediff, valuediff^2, valuediff^3, h.g[,m.g9],
    surplus*nosupl, surplus*h.g[,m.g9], surplus*Xbar.m)  %*% ipar.g.U9 + BEV0
  }

