# Go to directory with the main specification:

setwd("~/data/replication/code/solve_model/main_spec")

# Load functions for each period:

                   source("Spr12.R"); source("Wtr12.R"); source("Fal12.R")
source("Sum11.R"); source("Spr11.R"); source("Wtr11.R"); source("Fal11.R")
source("Sum10.R"); source("Spr10.R"); source("Wtr10.R"); source("Fal10.R")
source("Sum9.R") ; source("Spr9.R") ; source("Wtr9.R") ; source("Fal9.R")

# Define model solver function:

model.solve <- function()  {
           Spr12(); Wtr12(); Fal12()
  Sum11(); Spr11(); Wtr11(); Fal11()
  Sum10(); Spr10(); Wtr10(); Fal10()
  Sum9() ; Spr9() ; Wtr9() ; Fal9()
  }

# Save:

setwd("~/data/replication/created")

save.image("workingfile.RData")
