/* Get unweighted and weighted averages of individual characteristics */



* Load analytic file:

use dynamic_R

* Merge sampling weights:

merge 1:1 aid using covariates, keep(master match) keepusing(gswgt1)

* Indicator for parental education (college):

gen byte pcoll = paredu==3 | paredu==4

* Calculate averages:

global indvars black younger only pcoll

summarize $indvars urban grd9sep if cohort > 7
summarize $indvars urban grd9sep if cohort > 7 [aw=gswgt1]


